diff -r 1e55e1aa8b7f sys/netinet/tcp_output.c
--- a/sys/netinet/tcp_output.c	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_output.c	Fri Jul 11 13:32:06 2014 +1000
@@ -883,17 +1487,112 @@
 			}
 		}
 
+		if (len > sendwin)
+			kdb_break();
+
+		// XXXNJW need to address having a lock here.
+		MPCB_LOCK(tp->t_mpcb);
+
+		/*
+		 * XXXNJW: require an overhaul of tracking ds_snd_max. Currently the
+		 * async calls into
+		 */
+
+		/* Increment ds_snd_max by len if we are sending new data */
+		// should this not be the ds map start + len?
+		if (DSEQ_GT(tp->t_mpcb->ds_map_max, tp->t_mpcb->ds_snd_max))
+            tp->t_mpcb->ds_snd_max = tp->t_mpcb->ds_map_max;
+
+		if(tp->t_mpcb->doing_rxmit) {
+			mp_debug(DSMAP, 4, 0, "%s: d-rx, ds_snd_una: %u, tseq %u\n", __func__,
+			    (uint32_t) tp->t_mpcb->ds_snd_una, snd_dsmap->sf_seq_start);
+
+			/* just matching the original map for debugging purposes */
+			struct ds_map *a_map;
+			TAILQ_FOREACH(a_map, &tp->t_mpcb->mp_ds_sndmaps, mp_ds_map_next) {
+				if ((a_map->ds_map_start == snd_dsmap->ds_map_start)
+				    && (a_map != snd_dsmap)) { // don't match itself
+					mp_debug(DSMAP, 4, 0, "%s: %p org tseq %u, new tseq %u, "
+						"l %d\n", __func__, a_map, a_map->sf_seq_start,
+					    snd_dsmap->sf_seq_start, a_map->ds_map_len);
+				}
+			}
+
+		}
+
+//		if(map_unsent == 0)
+//			printf("%s: PSH map_start %u, len %u ds_snd_max %u\n", __func__,
+//			    (uint32_t) snd_dsmap->ds_map_start,
+//			    (uint32_t) snd_dsmap->ds_map_len,
+//			    (uint32_t) tp->t_mpcb->ds_snd_max);
+
+		MPCB_UNLOCK(tp->t_mpcb);
+
+		// error checking
+		if (tp->mp_active && tp->t_mpcb->ds_snd_una > tp->t_mpcb->ds_snd_max)
+			kdb_break();
+
+		/*
+		 * Complete sending data from the current map. Can allocate a new map
+		 * if there is more data available to send in the send buffer.
+		 */
+		if (map_offset + len >= snd_dsmap->ds_map_len) {
+			snd_dsmap->flags |= MAPF_IS_SENT;
+			mp_debug(DSMAP, 1, 0, "%s: Marked snd_dsmap %p as SENT, "
+				"map_len: %d, mbuf_start: %p, sf_seq_start: %u\n",
+				__func__, snd_dsmap, snd_dsmap->ds_map_len,
+				snd_dsmap->mbuf_start, snd_dsmap->sf_seq_start);
+
+			if(tp->t_mpcb->doing_rxmit)
+				mp_debug(DSMAP, 1, 0, "%s: Marked snd_dsmap %p as SENT, "
+					"dsn: %u, sf_seq_start: %u\n", __func__, snd_dsmap,
+					(uint32_t) snd_dsmap->ds_map_start,
+					snd_dsmap->sf_seq_start);
+
+			/*
+			 * XXXNJW: temporary
+			 * try to get a new map only if we dont need a FIN an
+			 * not in retransmit.
+			 */
+			if(((tp->t_flags & TF_NEEDFIN) &&
+			    snd_dsmap->sf_seq_start + snd_dsmap->ds_map_len == tp->snd_max)
+			    || (tp->t_rxtshift > 0))
+				snd_dsmap = NULL;
+			else {
+				/* XXXNJW: more data that can be sent? check for map now. this
+				 * will slow down multi-subflow connections (due to calling in
+				 * to find map and getting no return). */
+				snd_dsmap = mp_find_dsmap(tp, snd_dsmap->sf_seq_start +
+				   snd_dsmap->ds_map_len);
+			}
+
+			if (snd_dsmap != NULL) {
+				/* Have added more data that can be sent now */
+				map_unsent = snd_dsmap->ds_map_len;
+
+				/* If data level rexmit pending, override the scheduler and
+				 * send back-to-back (assuming room in sendwin). Also, if we
+				 * only have a single subflow, might as well send a windows
+				 * worth. */
+				if((snd_dsmap->flags & MAPF_IS_REXMIT) ||
+				    (tp->t_mpcb->subflow_cnt == 1))
+					sendalot = 1;
+			} else
+				map_unsent = 0;
+        }
+
 		/*
 		 * If we're sending everything we've got, set PUSH.
 		 * (This will keep happy those implementations which only
 		 * give data to the user when a buffer fills or
 		 * a PUSH comes in.)
-		 */
-		if (off + len == so->so_snd.sb_cc)
+		 *
+		 * Finished sending previous map and could not get more bytes
+		 * for this subflow */
+		if (map_unsent == 0) {
 			flags |= TH_PUSH;
-		SOCKBUF_UNLOCK(&so->so_snd);
+		}
 	} else {
-		SOCKBUF_UNLOCK(&so->so_snd);
 		if (tp->t_flags & TF_ACKNOW)
 			TCPSTAT_INC(tcps_sndacks);
 		else if (flags & (TH_SYN|TH_FIN|TH_RST))
@@ -918,7 +1617,6 @@
 		m->m_data += max_linkhdr;
 		m->m_len = hdrlen;
 	}
-	SOCKBUF_UNLOCK_ASSERT(&so->so_snd);
 	m->m_pkthdr.rcvif = (struct ifnet *)0;
 #ifdef MAC
 	mac_inpcb_create_mbuf(tp->t_inpcb, m);
@@ -945,6 +1643,7 @@
 	if (flags & TH_FIN && tp->t_flags & TF_SENTFIN &&
 	    tp->snd_nxt == tp->snd_max)
 		tp->snd_nxt--;
+
 	/*
 	 * If we are starting a connection, send ECN setup
 	 * SYN packet. If we are on a retransmit, we may
@@ -1022,11 +1721,12 @@
 	 * Calculate receive window.  Don't shrink window,
 	 * but avoid silly window syndrome.
 	 */
+	// XXXNJW should remove check against hiwater.
 	if (recwin < (long)(so->so_rcv.sb_hiwat / 4) &&
-	    recwin < (long)tp->t_maxseg)
+		recwin < (long)tp->t_maxseg)
 		recwin = 0;
 	if (SEQ_GT(tp->rcv_adv, tp->rcv_nxt) &&
-	    recwin < (long)(tp->rcv_adv - tp->rcv_nxt))
+		recwin < (long)(tp->rcv_adv - tp->rcv_nxt))
 		recwin = (long)(tp->rcv_adv - tp->rcv_nxt);
 	if (recwin > (long)TCP_MAXWIN << tp->rcv_scale)
 		recwin = (long)TCP_MAXWIN << tp->rcv_scale;
@@ -1080,6 +1780,7 @@
 	 * checksum extended header and data.
 	 */
 	m->m_pkthdr.len = hdrlen + len; /* in6_cksum() need this */
+	m->m_pkthdr.csum_flags = CSUM_TCP;
 	m->m_pkthdr.csum_data = offsetof(struct tcphdr, th_sum);
 #ifdef INET6
 	if (isipv6) {
@@ -1289,6 +1990,7 @@
 				tcp_timer_activate(tp, TT_PERSIST, 0);
 				tp->t_rxtshift = 0;
 			}
+
 			tcp_timer_activate(tp, TT_REXMT, tp->t_rxtcur);
 		}
 	} else {
@@ -1389,6 +2091,24 @@
 	tp->t_flags &= ~(TF_ACKNOW | TF_DELACK);
 	if (tcp_timer_active(tp, TT_DELACK))
 		tcp_timer_activate(tp, TT_DELACK, 0);
+
+//	if (sendalot) {
+//		sendwin -= len;
+//		if (sendwin < tp->t_maxseg)
+//			sendalot = 0;
+//	}
+
+	/* XXXNJW if we don't have room for an entire map, dont send.
+	 * This will be changed after testing, as we want to be able to send even
+	 * partial maps to make the most of whatever remains in the send window. */
+	if (sendalot) {
+		if ((sendwin - off - map_unsent) < tp->t_maxseg)
+			sendalot = 0;
+	}
+
+	if (sendalot && (sendwin < tp->t_maxseg))
+		kdb_break();
+
 #if 0
 	/*
 	 * This completely breaks TCP if newreno is turned on.  What happens
@@ -1401,6 +2121,7 @@
 #endif
 	if (sendalot)
 		goto again;
+
 	return (0);
 }
 
@@ -1523,6 +2244,15 @@
 				 *optp++ = 0;
 			break;
 			}
+		case TOF_MPTCP:
+			{
+			while (optlen % 2) {
+				optlen += TCPOLEN_NOP;
+				*optp++ = TCPOPT_NOP;
+			}
+			mp_addoptions(to, &optlen, optp);
+			break;
+			}
 		case TOF_SACK:
 			{
 			int sackblks = 0;
diff -r 1e55e1aa8b7f sys/netinet/tcp_reass.c
--- a/sys/netinet/tcp_reass.c	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_reass.c	Fri Jul 11 13:32:06 2014 +1000
@@ -37,6 +37,7 @@
 #include "opt_tcpdebug.h"
 
 #include <sys/param.h>
+#include <sys/kdb.h>
 #include <sys/kernel.h>
 #include <sys/malloc.h>
 #include <sys/mbuf.h>
@@ -69,12 +70,19 @@
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
+#include <netinet/mptcp_var.h>
+
 #include <netinet6/tcp6_var.h>
 #include <netinet/tcpip.h>
 #ifdef TCPDEBUG
 #include <netinet/tcp_debug.h>
 #endif /* TCPDEBUG */
 
+#define TAILQ_FOREACH_CONTINUE(var, head, field)                        \
+        for ((var) = ((var) ? (var) : TAILQ_FIRST((head)));             \
+        (var);                                                          \
+        (var) = TAILQ_NEXT((var), field))
+
 static SYSCTL_NODE(_net_inet_tcp, OID_AUTO, reass, CTLFLAG_RW, 0,
     "TCP Segment Reassembly Queue");
 
@@ -140,13 +148,14 @@
 
 	INP_WLOCK_ASSERT(tp->t_inpcb);
 
-	while ((qe = LIST_FIRST(&tp->t_segq)) != NULL) {
-		LIST_REMOVE(qe, tqe_q);
+	while ((qe = TAILQ_FIRST(tp->t_segq)) != NULL) {
+		TAILQ_REMOVE(tp->t_segq, qe, tqe_q);
 		m_freem(qe->tqe_m);
 		uma_zfree(V_tcp_reass_zone, qe);
 		tp->t_segqlen--;
 	}
 
+	tp->t_segqlen = 0;
 	KASSERT((tp->t_segqlen == 0),
 	    ("TCP reass queue %p segment count is %d instead of 0 after flush.",
 	    tp, tp->t_segqlen));
@@ -159,13 +168,19 @@
 	struct tseg_qent *p = NULL;
 	struct tseg_qent *nq;
 	struct tseg_qent *te = NULL;
+	struct tseg_qent *prev_disorder;
 	struct socket *so = tp->t_inpcb->inp_socket;
 	char *s = NULL;
 	int flags;
 	struct tseg_qent tqs;
+	struct mpcb *mp = tp->t_mpcb;
 
 	INP_WLOCK_ASSERT(tp->t_inpcb);
 
+	flags = 0;
+
+	SF_REASS_RLOCK(mp);
+
 	/*
 	 * XXX: tcp_reass() is rather inefficient with its data structures
 	 * and should be rewritten (see NetBSD for optimizations).
@@ -175,8 +190,12 @@
 	 * Call with th==NULL after become established to
 	 * force pre-ESTABLISHED data up to user socket.
 	 */
-	if (th == NULL)
-		goto present;
+	if (th == NULL) {
+		if(TAILQ_EMPTY(tp->t_segq))
+			goto unlock_return;
+		else
+			goto present;
+	}
 
 	/*
 	 * Limit the number of segments that can be queued to reduce the
@@ -194,19 +213,21 @@
 	 * Investigate why and re-evaluate the below limit after the behaviour
 	 * is understood.
 	 */
-	if ((th->th_seq != tp->rcv_nxt || !TCPS_HAVEESTABLISHED(tp->t_state)) &&
-	    tp->t_segqlen >= (so->so_rcv.sb_hiwat / tp->t_maxseg) + 1) {
-		V_tcp_reass_overflows++;
-		TCPSTAT_INC(tcps_rcvmemdrop);
-		m_freem(m);
-		*tlenp = 0;
-		if ((s = tcp_log_addrs(&tp->t_inpcb->inp_inc, th, NULL, NULL))) {
-			log(LOG_DEBUG, "%s; %s: queue limit reached, "
-			    "segment dropped\n", s, __func__);
-			free(s, M_TCPLOG);
-		}
-		return (0);
-	}
+
+	/* XXXNJW: Need to revisit this in re to receive window advertising */
+//	if (th->th_seq != tp->rcv_nxt &&
+//	    tp->t_segqlen >= (so->so_rcv.sb_hiwat / tp->t_maxseg) + 1) {
+//		V_tcp_reass_overflows++;
+//		TCPSTAT_INC(tcps_rcvmemdrop);
+//		m_freem(m);
+//		*tlenp = 0;
+//		if ((s = tcp_log_addrs(&tp->t_inpcb->inp_inc, th, NULL, NULL))) {
+//			log(LOG_DEBUG, "%s; %s: queue limit reached, "
+//			    "segment dropped\n", s, __func__);
+//			free(s, M_TCPLOG);
+//		}
+//		goto unlock_return;
+//	}
 
 	/*
 	 * Allocate a new queue entry. If we can't, or hit the zone limit
@@ -227,7 +248,7 @@
 				    "reached, segment dropped\n", s, __func__);
 				free(s, M_TCPLOG);
 			}
-			return (0);
+			goto unlock_return;
 		} else {
 			bzero(&tqs, sizeof(struct tseg_qent));
 			te = &tqs;
@@ -242,10 +263,28 @@
 	}
 	tp->t_segqlen++;
 
+	prev_disorder = tp->t_segq->disordered;
+
+	/*
+	 * 'fastpath' check
+	 */
+	if (th->th_seq == tp->rcv_nxt && !tp->t_segq->disordered) {
+		p = TAILQ_LAST(tp->t_segq, sf_reass_queue_head);
+		mp_debug(REASS, 5, 0, "%s: goto fastpath\n",__func__);
+		goto fastpath;
+	}
+
+	/*
+	 * setting to te is temp until we know exactly where
+	 * disorder starts
+	 */
+	if (tp->t_segq->disordered == NULL)
+		tp->t_segq->disordered = te;
+
 	/*
 	 * Find a segment which begins after this one does.
 	 */
-	LIST_FOREACH(q, &tp->t_segq, tqe_q) {
+	TAILQ_FOREACH(q, tp->t_segq, tqe_q) {
 		if (SEQ_GT(q->tqe_th->th_seq, th->th_seq))
 			break;
 		p = q;
@@ -269,12 +308,12 @@
 					uma_zfree(V_tcp_reass_zone, te);
 				tp->t_segqlen--;
 				/*
-				 * Try to present any queued data
-				 * at the left window edge to the user.
-				 * This is needed after the 3-WHS
-				 * completes.
+				 * Already have data in queue that this segment provided.
+				 * Queue is still disordered, return and send a DUP ACK
 				 */
-				goto present;	/* ??? */
+				mp_debug(REASS, 5, 0, "%s: queue still disordered, "
+				    "goto unlock_return\n",__func__);
+				goto unlock_return;
 			}
 			m_adj(m, i);
 			*tlenp -= i;
@@ -294,59 +333,389 @@
 		if (i <= 0)
 			break;
 		if (i < q->tqe_len) {
+			mp_debug(REASS, 5, 0, "%s: trim segment %u len %d, overlaps %u", __func__,
+			     th->th_seq,  *tlenp, q->tqe_th->th_seq);
 			q->tqe_th->th_seq += i;
+			q->tqe_dsn += i;
 			q->tqe_len -= i;
 			m_adj(q->tqe_m, i);
 			break;
 		}
-
-		nq = LIST_NEXT(q, tqe_q);
-		LIST_REMOVE(q, tqe_q);
+		nq = TAILQ_NEXT(q, tqe_q);
+		TAILQ_REMOVE(tp->t_segq, q, tqe_q);
 		m_freem(q->tqe_m);
 		uma_zfree(V_tcp_reass_zone, q);
 		tp->t_segqlen--;
 		q = nq;
 	}
 
+fastpath:
 	/* Insert the new segment queue entry into place. */
 	te->tqe_m = m;
 	te->tqe_th = th;
 	te->tqe_len = *tlenp;
+	te->tqe_dsn = 0;
+
+	if (te->tqe_len > 0) {
+		struct m_tag *mtag =  m_tag_locate(m, PACKET_COOKIE_MPTCP,
+			PACKET_TAG_DSN, NULL);
+		KASSERT(mtag != NULL, ("%s segment of len %d is missing an mbuf tag\n",
+			__func__, te->tqe_len));
+		te->tqe_dsn = ((struct dsn_tag *)mtag)->dsn;
+	}
 
 	if (p == NULL) {
-		LIST_INSERT_HEAD(&tp->t_segq, te, tqe_q);
+		mp_debug(REASS, 3, 0, "%s: insert segment at queue head, sqn: %u\n",
+		    __func__, th->th_seq);
+		/* Queue is empty so insert at head. */
+		TAILQ_INSERT_HEAD(tp->t_segq, te, tqe_q);
+		if (th->th_seq == tp->rcv_nxt) {
+			/*
+			 * Search from segment just inserted towards end of list looking
+			 * for a hole.
+			 */
+			q = te;
+			TAILQ_FOREACH_CONTINUE(q, tp->t_segq, tqe_q) {
+				nq = TAILQ_NEXT(q, tqe_q);
+				if (nq != NULL &&
+				    q->tqe_th->th_seq + q->tqe_len != nq->tqe_th->th_seq) {
+					/* Found the first out of sequence segment in
+					 * the reass list. */
+					tp->t_segq->disordered = nq;
+					break;
+				}
+			}
+			/* get through list without finding disorder */
+			if (q == NULL)
+				tp->t_segq->disordered = NULL;
+		} else {
+			tp->t_segq->disordered = TAILQ_FIRST(tp->t_segq);
+		}
 	} else {
+		/* Otherwise put it in sequence order in queue. */
+		mp_debug(REASS, 3, 0, "%s: insert segment in queue in sq order, "
+		    "sqn: %u, rcv_nxt: %u\n",__func__, th->th_seq, tp->rcv_nxt);
 		KASSERT(te != &tqs, ("%s: temporary stack based entry not "
 		    "first element in queue", __func__));
-		LIST_INSERT_AFTER(p, te, tqe_q);
+		TAILQ_INSERT_AFTER(tp->t_segq, p, te, tqe_q);
+
+		if (te == TAILQ_LAST(tp->t_segq, sf_reass_queue_head)) {
+			if(th->th_seq == tp->rcv_nxt) //inserted rcv_nxt at end of queue
+				tp->t_segq->disordered = NULL;
+		} else {
+			/* search through till we find a disorderd segment*/
+			q = TAILQ_FIRST(tp->t_segq);
+			TAILQ_FOREACH(q, tp->t_segq, tqe_q) {
+				nq = TAILQ_NEXT(q, tqe_q);
+				if (nq != NULL &&
+					q->tqe_th->th_seq + q->tqe_len != nq->tqe_th->th_seq) {
+					/* Found the first out of sequence segment
+					 * in the reass list. */
+					tp->t_segq->disordered = nq;
+					break;
+				}
+			}
+
+			/* Did not find any out of order segments, clear disordered. */
+			if (q == NULL)
+				tp->t_segq->disordered = NULL;
+		}
+
+	}
+	/* end insertion into segment queue */
+
+	if(tp->t_segq->disordered) {
+		if (prev_disorder == NULL)
+			mp_debug(REASS, 4, 0, "%s: queue became disordered at sqn %u after receiving sqn %u, rcv_nxt: %u, ds_rcv_nxt: %u\n",
+				__func__, tp->t_segq->disordered->tqe_th->th_seq, th->th_seq, tp->rcv_nxt, (uint32_t) mp->ds_rcv_nxt);
+		else if (prev_disorder != tp->t_segq->disordered)
+			mp_debug(REASS, 4, 0, "%s: queue remains disordered but progressed from sqn %u to sqn %u after receiving sqn %u, rcv_nxt: %u, ds_rcv_nxt: %u\n",
+		    __func__, prev_disorder->tqe_th->th_seq, tp->t_segq->disordered->tqe_th->th_seq, th->th_seq, tp->rcv_nxt, (uint32_t) mp->ds_rcv_nxt);
+		else
+			mp_debug(REASS, 4, 0, "%s: queue remains disordered at sqn %u after receiving sqn %u, rcv_nxt: %u, ds_rcv_nxt: %u\n",
+		    __func__, tp->t_segq->disordered->tqe_th->th_seq, th->th_seq, tp->rcv_nxt, (uint32_t) mp->ds_rcv_nxt);
+
+	} else {
+		if (prev_disorder)
+			mp_debug(REASS, 4, 0, "%s: queue transitioned from disordered at sqn %u to ordered after receiving sqn: %u\n",
+					__func__, prev_disorder->tqe_th->th_seq, th->th_seq);
+		else
+			mp_debug(REASS, 4, 0, "%s: queue is not disordered, sqn: %u, rcv_nxt: %u\n",__func__, th->th_seq, tp->rcv_nxt);
 	}
 
 present:
+
+	mp_debug(REASS, 5, 0, "%s: present sqn %u\n",__func__, th->th_seq);
+
 	/*
 	 * Present data to user, advancing rcv_nxt through
 	 * completed sequence space.
+	 *
+	 * If connection not established then return.
+	 *
+	 * If the queue is empty, or the first element is not the next expected,
+	 * then return.
 	 */
-	if (!TCPS_HAVEESTABLISHED(tp->t_state))
-		return (0);
-	q = LIST_FIRST(&tp->t_segq);
-	if (!q || q->tqe_th->th_seq != tp->rcv_nxt)
-		return (0);
+	if (!TCPS_HAVEESTABLISHED(tp->t_state)) {
+		goto unlock_return;
+	}
+
+	/*
+	 * If there is some amount of in-order data we know that rcv_nxt
+	 * can be set to the sequence number of the highest byte received.
+	 * If the previous element to the first disordered segment is NULL,
+	 * it means we have no in-order data.
+	 */
+	if (tp->t_segq->disordered) {
+		nq = TAILQ_PREV(tp->t_segq->disordered, sf_reass_queue_head, tqe_q);
+		if (nq != NULL) {
+			mp_debug(REASS, 3, 0, "%s: queue is disordered, but contains in "
+					"sequence data, changing rcv_nxt from: %u to %u\n",
+			    __func__, tp->rcv_nxt, nq->tqe_th->th_seq + nq->tqe_len);
+			tp->rcv_nxt = nq->tqe_th->th_seq + nq->tqe_len;
+		} else {
+			// in this else the first element of the list is disordered,
+			// return immediately
+			goto unlock_return;
+		}
+
+	} else {
+		nq = TAILQ_LAST(tp->t_segq, sf_reass_queue_head);
+		tp->rcv_nxt = nq->tqe_th->th_seq + nq->tqe_len;
+
+		/*
+		 * if the last segment in the list has a FIN and we are not disordered
+		 * indicate to tcp_input that a FIN has been delivered.
+		 */
+		flags = nq->tqe_th->th_flags & TH_FIN;
+
+		if (tp->mp_active) {
+			mp_debug(REASS, 3, 0, "%s: queue is ordered, "
+				"rcv_nxt changed from: %u to %u. diff: %u tail_dsn: %u\n",
+				__func__, tp->rcv_nxt, nq->tqe_th->th_seq + nq->tqe_len,
+				(nq->tqe_th->th_seq + nq->tqe_len - tp->rcv_nxt),
+				(uint32_t) nq->tqe_dsn);
+			mp_debug(REASS, 3, 0, "%s: queue is ordered, "
+				"first dsn: %u \n",
+				__func__, (uint32_t) TAILQ_FIRST(tp->t_segq)->tqe_dsn);
+
+		}
+	}
+
+	/* is this segment next in data sequence order? */
+	q = TAILQ_FIRST(tp->t_segq);
+
+	/* XXXNJW: need to detect wrapping */
+	KASSERT((q->tqe_dsn >= tp->t_mpcb->ds_rcv_nxt ||
+			q->tqe_dsn <= tp->t_mpcb->ds_rcv_nxt + tp->rcv_wnd)		// good test for in-window?
+			|| q->tqe_th->th_flags & TH_FIN,
+	    ("%s: Segment DSN %u less than ds_rcv_nxt %u\n", __func__,
+	    (uint32_t)q->tqe_dsn,
+	    (uint32_t)tp->t_mpcb->ds_rcv_nxt));
+
+	// XXXNJW: be careful about reading ds_rcv_nxt
+	if (tp->t_segq->disordered == q) {
+		if (tp->mp_enabled)
+			mp_debug(REASS, 4, 0, "%s: goto unlock return "
+					"sqn:%u, direct_map:%d, tqe_dsn: %u, "
+					"tqe_len: %d, ds_rcv_nxt %u, tp_rcv_nxt: %u\n",
+					__func__, th->th_seq, tp->infinite_map, (uint32_t)
+					q->tqe_dsn, q->tqe_len, (uint32_t)tp->t_mpcb->ds_rcv_nxt,
+					tp->rcv_nxt);
+		goto unlock_return;
+	}
+
+	SF_REASS_RUNLOCK(mp);
+
+	if(!tp->infinite_map) {
+		/* Schedule a data level ACK on next subflow through tcp_output */
+		//tp->sf_flags |= SFF_NEED_DACK;
+	}
+
+	/*
+	 * XXXNJW: This is a temporary hack to allow upcalls that
+	 * require a certain number of bytes (sb_cc) before calling
+	 * soreceive() to work with deferred reassembly. In these
+	 * cases reassembly occurs in the subflow context rather than
+	 * in the context of the receiving process.
+	 */
 	SOCKBUF_LOCK(&so->so_rcv);
-	do {
-		tp->rcv_nxt += q->tqe_len;
-		flags = q->tqe_th->th_flags & TH_FIN;
-		nq = LIST_NEXT(q, tqe_q);
-		LIST_REMOVE(q, tqe_q);
-		if (so->so_rcv.sb_state & SBS_CANTRCVMORE)
-			m_freem(q->tqe_m);
-		else
-			sbappendstream_locked(&so->so_rcv, q->tqe_m);
-		if (q != &tqs)
-			uma_zfree(V_tcp_reass_zone, q);
-		tp->t_segqlen--;
-		q = nq;
-	} while (q && q->tqe_th->th_seq == tp->rcv_nxt);
+
+//	if (tp->mp_active) {
+//		if (tp->t_segq->disordered) {
+//			// XXXNJW checking for rcv_nxt passing
+//			if (SEQ_GT(tp->rcv_nxt, tp->t_segq->disordered->tqe_th->th_seq)) {
+//				printf("%s: rcv_nxt %u > 1st dis seg %u tp %p\n ", __func__,
+//					tp->rcv_nxt, tp->t_segq->disordered->tqe_th->th_seq, tp);
+//				kdb_break();
+//			}
+//		}
+//
+//		// checking for a significant difference between rcv_nxt and rcv_adv. this
+//		// would indicate a sequence space mess up. might trigger falsely on wraps
+//		// but should be okay for debug
+//		if((0xf0000000 & tp->rcv_adv) != (0xf0000000 & tp->rcv_nxt)) {
+//			printf("%s: rcv_adv: %u, rcv_next %u, tp %p\n", __func__, tp->rcv_adv,
+//				tp->rcv_nxt, tp);
+//			kdb_break();
+//		}
+//	}
+	//if (so->so_rcv.sb_upcall != NULL)
+		mp_do_reass(tp);
+
+	//XXXNJW: Does this belong here or in do_reass?
 	ND6_HINT(tp);
 	sorwakeup_locked(so);
+
+	return (flags);
+
+unlock_return:
+	SF_REASS_RUNLOCK(mp);
 	return (flags);
 }
+
+void
+mp_do_reass(struct tcpcb *tp) {
+
+//error = m_mbuftouio(uio, sb->sb_mb, len);
+
+	/* XXX this is where we walk the subflow lists looking for
+	 * a segment matching dss rcv_nxt (there will always be at
+	 * least one in here before sorwakeup is called).
+	 * as we find in-sequence segments, pass them up to wherever,
+	 * then take the segment out of the list and release the mbuf.
+	 *
+	 * could cheat and call appendstream here?
+	 */
+	struct socket *so = tp->t_inpcb->inp_socket;
+	struct mpcb *mp;
+	struct tseg_qent *nq = NULL;
+	struct tseg_qent *q = NULL;
+	struct sockbuf *sb;
+	uint64_t prev_ds_rcv_nxt;
+
+	sb = &so->so_rcv;
+
+	SOCKBUF_LOCK_ASSERT(sb);
+
+	if (!tp)
+		return;
+
+	mp = tp->t_mpcb;
+	KASSERT(mp != NULL,("%s: No mp control block for TCP flow\n", __func__));
+
+	mp->ds_last_dack_sent = prev_ds_rcv_nxt = mp->ds_rcv_nxt;
+
+	mp_debug(REASS, 3, 0, "%s:  "
+	    "ds_rcv_nxt %u, tp_rcv_nxt: %u\n",
+	    __func__, (uint32_t) tp->t_mpcb->ds_rcv_nxt, tp->rcv_nxt);
+
+	/*
+	 * Search through subflow lists for in-order segments. if
+	 * found, remove from the list, append to sb and release
+	 * the mbuf
+	 *
+	 * XXXNJW this is inefficient when there are lots of subflows
+	 * Need to change so that if an in-order segment is found, then
+	 */
+	SF_REASS_WLOCK(mp);
+
+	int seg_count = 0;
+
+	struct tcpcb *subflow_tp = NULL;
+start_reass_head_list:
+	SLIST_FOREACH(subflow_tp, &mp->tp_list, next_subflow) {
+		TAILQ_FOREACH(q, subflow_tp->t_segq, tqe_q) {
+			if (!q)
+				continue;
+
+			/* remove segments that have been passed by the sf rcv_nxt and
+			 * data_level rcv_nxt. Can happen due to rexmits */
+			if (q->tqe_dsn < mp->ds_rcv_nxt
+			    && q->tqe_th->th_seq < subflow_tp->rcv_nxt) {
+				mp_debug(REASS, 2, 0, "%s: removing bypassed segment %u\n",
+					__func__, (uint32_t) q->tqe_dsn);
+				TAILQ_REMOVE(subflow_tp->t_segq, q, tqe_q);
+				uma_zfree(V_tcp_reass_zone, q);
+				subflow_tp->t_segqlen--;
+				continue;
+			}
+
+			if (q->tqe_dsn == mp->ds_rcv_nxt) {
+				do {
+					/* Retransmits might cause data-level holes to be filled in
+					 * by alternate subflows. If the data-level has caught up
+					 * to whatever was received on the subflow, but the subflow
+					 * has not yet caught up its own rexmits (i.e. rcv_nxt is
+					 * still somewhere earlier than this segment), should skip
+					 * over the segment and wait for the data to be rexmitted.
+					 */
+					if (SEQ_GT(q->tqe_th->th_seq, subflow_tp->rcv_nxt)) {
+						mp_debug(REASS, 3, 0, "%s: skipped map %p dsn %u\n",
+						    __func__, q, (uint32_t) q->tqe_dsn);
+						q = TAILQ_NEXT(q, tqe_q);
+						continue;
+					}
+
+					/* If we are here and the first segment is disordered,
+					 * will need to stop and take a look as to why. */
+					// might want to catch when th_seq > rcv_nxt
+					// even when in data-seq order.
+					if (q == subflow_tp->t_segq->disordered) {
+						printf("%s: dis %p is ds_rcv_nxt\n", __func__, q);
+						kdb_break();
+					}
+
+					seg_count++;
+					mp->ds_rcv_nxt += q->tqe_len;
+					// just a test hard sync'ing sf seq nums's
+					if(tp->infinite_map)
+						tp->rcv_nxt = mp->ds_rcv_nxt;
+					nq = TAILQ_NEXT(q, tqe_q);
+					TAILQ_REMOVE(subflow_tp->t_segq, q, tqe_q);
+					if (so->so_rcv.sb_state & SBS_CANTRCVMORE)
+						m_freem(q->tqe_m);
+					else
+						sbappendstream_locked(&so->so_rcv, q->tqe_m);
+					uma_zfree(V_tcp_reass_zone, q);
+					subflow_tp->t_segqlen--;
+					mp_debug(REASS, 5, 0, "*%s: appended dsn: %u\n", __func__,
+					    (uint32_t) q->tqe_dsn);
+					q = nq;
+					if (q)
+						mp_debug(REASS, 5, 0, "%s: next dsn: %u *\n", __func__,
+							(uint32_t) q->tqe_dsn);
+				} while (q && q->tqe_dsn == mp->ds_rcv_nxt && q != subflow_tp->t_segq->disordered);
+				goto start_reass_head_list;
+			} else if ((q->tqe_len == 0 &&
+				(q->tqe_th->th_flags & TH_FIN) && !tp->t_segq->disordered)
+				|| q->tqe_dsn < mp->ds_rcv_nxt) {
+					TAILQ_REMOVE(subflow_tp->t_segq, q, tqe_q);
+					m_freem(q->tqe_m);
+					uma_zfree(V_tcp_reass_zone, q);
+					subflow_tp->t_segqlen--;
+					/* XXXNJW: In the q->tqe_dsn < mp->ds_rcv_nxt case,
+					 * ideally want to continue from the next element in the
+					 * current list, rather than from the first element in the
+					 * first list. */
+					goto start_reass_head_list;
+			}
+		}
+	}
+
+	SF_REASS_WUNLOCK(mp);
+
+	mp_debug(REASS, 3, 0, "%s: exit vars"
+		"ds_rcv_nxt %u, tp_rcv_nxt: %u segments appended: %d\n",
+		__func__, (uint32_t) tp->t_mpcb->ds_rcv_nxt, tp->rcv_nxt, seg_count);
+
+	if(!tp->infinite_map && prev_ds_rcv_nxt < mp->ds_rcv_nxt) {
+		/* Schedule a data level ACK on next subflow through tcp_output */
+		mp->mp_flags |= MPO_DATA_ACK;
+
+		//OR schedule DACK for the current subflow?
+		//might this cause issues of DACKs being delayed?
+		tp->sf_flags |= SFF_NEED_DACK;
+	}
+}
+
diff -r 1e55e1aa8b7f sys/netinet/tcp_sack.c
--- a/sys/netinet/tcp_sack.c	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_sack.c	Fri Jul 11 13:32:06 2014 +1000
@@ -81,6 +81,7 @@
 #include <sys/systm.h>
 #include <sys/kernel.h>
 #include <sys/sysctl.h>
+#include <sys/limits.h>
 #include <sys/malloc.h>
 #include <sys/mbuf.h>
 #include <sys/proc.h>		/* for proc0 declaration */
@@ -115,6 +116,7 @@
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
+#include <netinet/mptcp_var.h>
 #include <netinet6/tcp6_var.h>
 #include <netinet/tcpip.h>
 #ifdef TCPDEBUG
@@ -570,7 +572,7 @@
  * the midst of sack recovery.
  */
 void
-tcp_sack_partialack(struct tcpcb *tp, struct tcphdr *th)
+tcp_sack_partialack(struct tcpcb *tp, struct tcphdr *th, uint32_t acked)
 {
 	int num_segs = 1;
 
@@ -578,7 +580,7 @@
 	tcp_timer_activate(tp, TT_REXMT, 0);
 	tp->t_rtttime = 0;
 	/* Send one or 2 segments based on how much new data was acked. */
-	if ((BYTES_THIS_ACK(tp, th) / tp->t_maxseg) >= 2)
+	if ((acked / tp->t_maxseg) >= 2)
 		num_segs = 2;
 	tp->snd_cwnd = (tp->sackhint.sack_bytes_rexmit +
 	    (tp->snd_nxt - tp->sack_newdata) + num_segs * tp->t_maxseg);
